//
//  omanager.cpp
//  ooo....... manager source
//

/*
    Friday 96Feb09 11:14:22 AM From Golden Spud @ Golden Spud's Greasehouse,
Ferndale, USA/WA/WHATCOM, 360-380-1072
    %%skr.olm: 823945893, 0:14:37
Basically, here is how you use it: 
  
 o_reset('', '', 60, 2048000); 
          ^    ^    ^     ^-------reallen -- len of msgbase, for instance 
          |    |    `-------------screenlen - how long you want bar to be 
          |    `------------------fillchar - what you want to fill with 
          `-----------------------startchar - what you want to start with 
  
 and, in your loop(s): 
  
 o_update(msgbyte); 
            ^------- current byte in relation to the real length. 
                     (the correct screen length is calculated, using integer 
                      math, based on this, and is updated if necessary) 
*/

#define __OMANAGER_CPP

#include "coutput.h"
#include "omanager.h"

static  char start_ch;
static  char fill_ch;
static  long screenlen;
static  long screencur;
static  long reallen;
static  long realcur;

void o_update(long rl)
{
    long osc = screencur;
    if (rl > realcur)
        realcur = rl;
    else
        return;

    screencur = (realcur * screenlen) / reallen;
    long diffcur = screencur - osc;
    for (long i = 0; i < diffcur; i++) {
//      keyboard->fillbuffer();
        con_outchar(fill_ch);
    }
}

void o_reset(char s, char f, long sl, long rl)
{
    start_ch = s;
    fill_ch = f;
    screenlen = sl;
    screencur = 0;
    reallen = rl;
    realcur = 0;

    for (long i = 0; i < screenlen; i++)
        con_outchar(start_ch);
    for (i = 0; i < screenlen; i++)
        con_outchar('\b');
}
