#ifndef SUPPORT_H_
#define SUPPORT_H_

#define FNLEN		256
#define FIELDLEN	8192
#define ROOMLEN 	30

#define GETMSG_OK		0
#define GETMSG_EOF		1
#define GETMSG_BADMSG	2	// end of file reached but no M field
#define GETMSG_ENDROOM	3	// only a null was read

#define CTRL_A 1
#define CTRL_B 2

struct message_field_t {
	char fieldid;
	char *fieldtext;
	message_field_t *next;
}; // struct

struct message_t {
	char number[ROOMLEN+1];
	message_field_t *first;
}; // struct


void stripansi(char *str);
int u_match(register char *s, register char *p);
static char *cclass(register char *p, register int sub);
void getstr(FILE *f, char *str, int mlen);
void putstr(FILE *f, const char *str);
int get_message(FILE *f, message_t& msg);
void put_message(FILE *f, const message_t& msg);
void kill_message(message_t& msg);
int search_message(const message_t& msg, char field, char *test, int dansi);

#endif // SUPPORT_H_
